/***************************************************************************
 *                                                                         *
 *       The information  contained herein is  PROPRIETARY  and            *
 *          CONFIDENTIAL to NewMonics Inc.  Patents pending.               *
 *                                                                         *
 *       Copyright (C) 1997 NewMonics Inc., All Rights reserved.           *
 *                                                                         *
 ***************************************************************************/

package demo.BlackJack;

import java.lang.Math;
import java.lang.System;
import java.io.IOException;

import COM.newmonics.picoPERC.MM;

public class KeyboardViaJava implements Input
{
  public int getBet()
  {
    int bet = 0;
    byte[] buf = new byte[10];
    
    try
    {
      System.in.read(buf, 0, buf.length);

      //
      // figure out how many digits there are
      //
      int num_digits = 0;
      while (buf[num_digits] >= '0' && buf[num_digits] <= '9')
      {
        num_digits++;
      }

      //
      // convert the numbers in the buffer (which are represented
      // as ASCII characters) to a single number
      //
      for (int i = 0; i < num_digits; i++)
      {
        double exp = (double)(num_digits - i - 1);
        bet += (buf[i] - '0') * (int)(Math.pow(10.0, exp));
      }
    }
    catch (IOException e)
    {
      System.err.println("oh oh, i/o exception in getBet!");
    }
    finally
    {
      MM.delete(buf);
    }
    
    return bet;
  }

  public char getAction()
  {
    int ch = 'x';
    
    try
    {
      ch = System.in.read();
      if (ch != '\n')
      {
        //
        // we've got our input, now just flush the input stream
        //
        while (System.in.read() != '\n');
      }
      else
      {
        //
        // the user simply hit return
        //
        ch = 'x';
      }
    }
    catch (IOException e)
    {
      System.err.println("oh oh, i/o exception in getAction!");
    }

    return (char) ch;
  }
}
