//
// Dib.h
//
// Transparent Control OCX
// Tom Armstrong & Mark Nelson
// September 1997
//
// This is a utility class used to contain a DIB.
// It provides a little encapsulation to make the
// rest of the project easier to follow.
//

class CDib
{
public:
  CDib();
  ~CDib();

  void Reset();
  BOOL SetBitmapInfoHeader( BYTE* );
  DWORD GetImageSize();
  DWORD Create( HDC hdc );
  void SetBits( BYTE* buffer );
  DWORD DrawTo( HDC hdc );
  operator HDC() { return m_memDC; }
  DWORD GetHeaderSize() { return m_dwHeaderSize; }
  long GetWidth() { return m_lWidth; }
  long GetHeight() { return m_lHeight; }
  BOOL IsInitialized() { return m_bInitialized; }
private:
  union {
    BITMAPINFO* p;
    BYTE* pBytes;
  } m_uBMI;
  BOOL m_bInitialized;
  DWORD m_dwHeaderSize;
  DWORD m_dwImageSize;
  BYTE* m_pbBits;
  HDC m_memDC;
  HBITMAP m_hSection;
  HBITMAP m_hOldBitmap;
  LONG m_lHeight;
  LONG m_lWidth;
};

