// Methods for drawing on a GraphicsWindow.
//
package jx;

public class GraphicsContext
   {
   // Create a new drawing context with default background, foreground, font, clipping region, etc.
   // Taken: window upon which to draw
   //
   public
   GraphicsContext(GraphicsWindow target)
      {
      create(target);
      }
   
   // Destroy this drawing context.
   // !!TODO: add a "finalize()" method that calls this automatically.
   public void
   dispose()
      {
      delete();
      }

   // Fill a rectangular region with background color.
   //
   public native void 
   clearRectangle(int x, int y, int w, int h);

   // Fill a rectangular region with foreground color.
   //
   public native void 
   fillRectangle(int x, int y, int w, int h);

   // Outline a rectangular region with foreground color.
   //
   public native void 
   drawRectangle(int x, int y, int w, int h);

   // Instance fields.
   //
   private int            sysHandle; // handle to o/s data for this graphics context
   private GraphicsWindow target;    // window upon which this gc is to draw

   // Implementation details.
   //
   private native void    create(GraphicsWindow target); // create o/s counterpart
   private native void    delete();                      // delete o/s counterpart
   }
