// Definition of profiler data point as used by jx.Profiler
//
// 13 Jun 1997 John Whaley
//

package jx.profiler;

public class ProfilePoint
{

	public static final int JAVA_TYPE =		1;
	public static final int VM_TYPE =		2;
	public static final int NATIVE_TYPE =	3;
	public static final int END_OF_DATA_TYPE = 127;
	public String methodName;
	public int lineNum;
	protected byte type;

	public ProfilePoint(byte type, int lineNum, String methodName)
	{
		this.type = type;
		this.lineNum = lineNum;
		this.methodName = methodName;
	}
	public boolean isJavaMethod()	{ return (type==JAVA_TYPE); }
	public boolean isVM()			{ return (type==VM_TYPE);	}
	public boolean isNative()		{ return (type==NATIVE_TYPE);}

}
